/*
* 拡大と縮小(カメラ距離変更)
* use papervision3d
*/

package  {
	//必要なクラスのimport
	import flash.display.Sprite;
	import org.papervision3d.view.Viewport3D;
	import org.papervision3d.scenes.Scene3D;
	import org.papervision3d.cameras.Camera3D;
	import org.papervision3d.render.BasicRenderEngine;

	import org.papervision3d.objects.primitives.Sphere;
	import flash.events.Event;
	import org.papervision3d.materials.BitmapFileMaterial;

	import org.papervision3d.events.InteractiveScene3DEvent;

	public class Sample06 extends Sprite { //Spriteクラス継承
		public var viewport:Viewport3D;
		public var scene:Scene3D;
		public var camera:Camera3D;
		public var renderer:BasicRenderEngine;

		public var sphere:Sphere;
		public var sphere_bfm:BitmapFileMaterial;//貼り付け画像

		public var yaw_num:Number = 5.0;//回転度数
		public var move_num:Number = 20.0;//移動距離
		public var min_num:Number = 200.0;//最短距離
		public var max_num:Number = 3000.0;//最長距離
		
		public var over_boo:Boolean = false;//マウスが乗っているかどうかの判定

		//コンストラクタ
		public function Sample06() {
			init();//初期化関数開始
		}

		//初期化関数
		public function init(){

			//マウスイベントを受け取るために四つ目の引数(interactive)をtrueにすること
			viewport = new Viewport3D(550 , 400 , false , true);

			addChild(viewport);//viewportを表示ツリーに追加

			renderer = new BasicRenderEngine();
			scene = new Scene3D();

			camera = new Camera3D();

			//BitmapFileMaterialには画像URLを引数として渡す
			sphere_bfm = new BitmapFileMaterial("http://www.aoharu-b.com/cgi/sk/img/study_p3d/papervision3d03back.jpg");

			//マウスイベント送信を許可するため
			sphere_bfm.interactive = true;

			sphere = new Sphere(sphere_bfm);

			sphere.addEventListener(InteractiveScene3DEvent.OBJECT_OVER , onOver);//OVERイベント定義
			sphere.addEventListener(InteractiveScene3DEvent.OBJECT_OUT , onOut);//OUTイベント定義

			this.buttonMode = true;//ボタンカーソル形状変更

			scene.addChild(sphere);

			addEventListener(Event.ENTER_FRAME , onEnterFrame);//ENTER_FRAMEイベント定義

		}

		//ENTER_FRAME時関数
		public function onEnterFrame(event:Event):void {
			sphere.yaw(yaw_num);//回転軸に沿って回転
			
			//over_booの値によってカメラを前方あるいは後方へ移動させる
			if(over_boo != false){

				//カメラを前方へ移動
				//if文は最短距離以上に近づかないようにするため
				if(camera.distanceTo(sphere) > min_num + move_num)camera.moveForward(move_num);
				else camera.moveForward(camera.distanceTo(sphere) - min_num);

			}
			else{

				//カメラを後方へ移動
				//if文は最長距離以上に遠ざからないようにするため
				if(camera.distanceTo(sphere) < max_num - move_num)camera.moveBackward(move_num);
				else camera.moveBackward(max_num - camera.distanceTo(sphere));

			}
			renderer.renderScene(scene, camera, viewport);//描画
		}

		//OVER時関数
		public function onOver(event:InteractiveScene3DEvent):void {
			over_boo = true;
		}

		//OUT時関数
		public function onOut(event:InteractiveScene3DEvent):void {
			over_boo = false;
		}
	}
}